Index: sys/dev/ichiic/ig4_var.h
===================================================================
--- sys/dev/ichiic/ig4_var.h	(revision 0)
+++ sys/dev/ichiic/ig4_var.h	(working copy)
@@ -0,0 +1,119 @@
+/*
+ * Copyright (c) 2014 The DragonFly Project.  All rights reserved.
+ *
+ * This code is derived from software contributed to The DragonFly Project
+ * by Matthew Dillon <dillon@backplane.com> and was subsequently ported
+ * to FreeBSD by Michael Gmelin <freebsd@grem.de>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ * 3. Neither the name of The DragonFly Project nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific, prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+ * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
+ * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD$
+ */
+
+#ifndef _BUS_SMBUS_INTELGEN4_IG4_VAR_H_
+#define _BUS_SMBUS_INTELGEN4_IG4_VAR_H_
+
+#include "bus_if.h"
+#include "device_if.h"
+#include "pci_if.h"
+#include "smbus_if.h"
+
+#define IG4_RBUFSIZE	128
+#define IG4_RBUFMASK	(IG4_RBUFSIZE - 1)
+
+enum ig4_op { IG4_IDLE, IG4_READ, IG4_WRITE };
+
+struct ig4iic_softc {
+	device_t	dev;
+	struct		intr_config_hook enum_hook;
+	device_t	smb;
+	struct resource	*regs_res;
+	int		regs_rid;
+	struct resource	*intr_res;
+	int		intr_rid;
+	void		*intr_handle;
+	int		intr_type;
+	enum ig4_op	op;
+	int		cmd;
+	int		rnext;
+	int		rpos;
+	char		rbuf[IG4_RBUFSIZE];
+	int		error;
+	uint8_t		last_slave;
+	int		pci_attached : 1;
+	int		use_10bit : 1;
+	int		slave_valid : 1;
+	int		read_started : 1;
+	int		write_started : 1;
+
+	/*
+	 * Locking semantics:
+	 *
+	 * Functions implementing the smbus interface that interact
+	 * with the controller acquire an exclusive lock on call_lock
+	 * to prevent interleaving of calls to the interface and a lock on
+	 * io_lock right afterwards, to synchronize controller I/O activity.
+	 * 
+	 * The interrupt handler can only read data while no ig4iic_smb_* call
+	 * is in progress or while io_lock is dropped during mtx_sleep in
+	 * wait_status and set_controller. It is safe to drop io_lock in those
+	 * places, because the interrupt handler only accesses those registers:
+	 *
+	 * - IG4_REG_I2C_STA  (I2C Status)
+	 * - IG4_REG_DATA_CMD (Data Buffer and Command)
+	 * - IG4_REG_CLR_INTR (Clear Interrupt)
+	 *
+	 * Locking outside of those places is required to make the content
+	 * of rpos/rnext predictable (e.g. whenever data_read is called and in
+	 * smb_transaction).
+	 */
+	struct sx	call_lock;
+	struct mtx	io_lock;
+};
+
+typedef struct ig4iic_softc ig4iic_softc_t;
+
+/* Attach/Detach called from ig4iic_pci_*() */
+int ig4iic_attach(ig4iic_softc_t *sc);
+int ig4iic_detach(ig4iic_softc_t *sc);
+
+/* SMBus methods */
+extern smbus_callback_t ig4iic_smb_callback;
+extern smbus_quick_t    ig4iic_smb_quick;
+extern smbus_sendb_t    ig4iic_smb_sendb;
+extern smbus_recvb_t    ig4iic_smb_recvb;
+extern smbus_writeb_t   ig4iic_smb_writeb;
+extern smbus_writew_t   ig4iic_smb_writew;
+extern smbus_readb_t    ig4iic_smb_readb;
+extern smbus_readw_t    ig4iic_smb_readw;
+extern smbus_pcall_t    ig4iic_smb_pcall;
+extern smbus_bwrite_t   ig4iic_smb_bwrite;
+extern smbus_bread_t    ig4iic_smb_bread;
+extern smbus_trans_t    ig4iic_smb_trans;
+
+#endif

Index: sys/dev/isl/isl.c
===================================================================
--- sys/dev/isl/isl.c	(revision 0)
+++ sys/dev/isl/isl.c	(working copy)
@@ -0,0 +1,353 @@
+/*-
+ * Copyright (c) 2015 Michael Gmelin <freebsd@grem.de>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+/*
+ * Driver for intersil I2C ISL29018 Digital Ambient Light Sensor and Proximity
+ * Sensor with Interrupt Function, only tested connected over SMBus (ig4iic).
+ *
+ * Datasheet:
+ * http://www.intersil.com/en/products/optoelectronics/ambient-light-and-proximity-sensors/light-to-digital-sensors/ISL29018.html
+ * http://www.intersil.com/content/dam/Intersil/documents/isl2/isl29018.pdf
+ */
+
+#include <sys/param.h>
+#include <sys/bus.h>
+#include <sys/conf.h>
+#include <sys/event.h>
+#include <sys/fcntl.h>
+#include <sys/kernel.h>
+#include <sys/lock.h>
+#include <sys/lockmgr.h>
+#include <sys/malloc.h>
+#include <sys/mbuf.h>
+#include <sys/module.h>
+#include <sys/poll.h>
+#include <sys/sx.h>
+#include <sys/sysctl.h>
+#include <sys/systm.h>
+#include <sys/systm.h>
+#include <sys/uio.h>
+#include <sys/vnode.h>
+
+#include <dev/smbus/smbconf.h>
+#include <dev/smbus/smbus.h>
+#include <dev/isl/isl.h>
+
+#include "smbus_if.h"
+#include "bus_if.h"
+#include "device_if.h"
+
+#define ISL_METHOD_ALS		0x10
+#define ISL_METHOD_IR		0x11
+#define ISL_METHOD_PROX		0x12
+#define ISL_METHOD_RESOLUTION	0x13
+#define ISL_METHOD_RANGE	0x14
+
+struct isl_softc {
+	device_t	dev;
+	int		addr;
+
+	struct sx	isl_sx;
+};
+
+/* Returns < 0 on problem. */
+static int isl_read_sensor(device_t dev, int addr, uint8_t cmd_mask);
+
+/*
+ * Initialize the device
+ */
+static int
+init_device(device_t dev, int addr, int probe)
+{
+	static char bl_init[] = { 0x00 };
+
+	device_t bus;
+	int error;
+
+	bus = device_get_parent(dev);	/* smbus */
+
+	/*
+	 * init procedure: send 0x00 to test ref and cmd reg 1
+	 */
+	error = smbus_trans(bus, addr, REG_TEST,
+			    SMB_TRANS_NOCNT | SMB_TRANS_7BIT,
+			    bl_init, sizeof(bl_init), NULL, 0, NULL);
+	if (error)
+		goto done;
+
+	error = smbus_trans(bus, addr, REG_CMD1,
+			    SMB_TRANS_NOCNT | SMB_TRANS_7BIT,
+			    bl_init, sizeof(bl_init), NULL, 0, NULL);
+	if (error)
+		goto done;
+
+	pause("islinit", hz/100);
+
+done:
+	if (error)
+		device_printf(dev, "Unable to initialize\n");
+	return (error);
+}
+
+static int isl_probe(device_t);
+static int isl_attach(device_t);
+static int isl_detach(device_t);
+
+static int isl_sysctl(SYSCTL_HANDLER_ARGS);
+
+static devclass_t isl_devclass;
+
+static device_method_t isl_methods[] = {
+	/* device interface */
+	DEVMETHOD(device_probe,		isl_probe),
+	DEVMETHOD(device_attach,	isl_attach),
+	DEVMETHOD(device_detach,	isl_detach),
+
+	DEVMETHOD_END
+};
+
+static driver_t isl_driver = {
+	"isl",
+	isl_methods,
+	sizeof(struct isl_softc),
+};
+
+static int
+isl_probe(device_t dev)
+{
+	int addr;
+	int error;
+
+	addr = smbus_get_addr(dev);
+
+	/*
+	 * 0x44 - isl ambient light sensor on the acer c720.
+	 * (other devices might use other ids).
+	 */
+	if (addr != 0x44)
+		return (ENXIO);
+
+	error = init_device(dev, addr, 1);
+	if (error)
+		return (ENXIO);
+
+	device_set_desc(dev, "ISL Digital Ambient Light Sensor");
+
+	return (BUS_PROBE_VENDOR);
+}
+
+static int
+isl_attach(device_t dev)
+{
+	struct isl_softc *sc;
+	struct sysctl_ctx_list *sysctl_ctx;
+	struct sysctl_oid *sysctl_tree;
+	int addr;
+	int use_als;
+	int use_ir;
+	int use_prox;
+
+	sc = device_get_softc(dev);
+
+	if (!sc)
+		return (ENOMEM);
+
+	addr = smbus_get_addr(dev);
+
+	if (init_device(dev, addr, 0))
+		return (ENXIO);
+
+	sx_init(&sc->isl_sx, "ISL read lock");
+
+	sc->dev = dev;
+	sc->addr = addr;
+
+	sysctl_ctx = device_get_sysctl_ctx(dev);
+	sysctl_tree = device_get_sysctl_tree(dev);
+
+	use_als = isl_read_sensor(dev, addr, CMD1_MASK_ALS_ONCE) >= 0;
+	use_ir = isl_read_sensor(dev, addr, CMD1_MASK_IR_ONCE) >= 0;
+	use_prox = isl_read_sensor(dev, addr, CMD1_MASK_PROX_ONCE) >= 0;
+
+	if (use_als) {
+		SYSCTL_ADD_PROC(sysctl_ctx,
+	 		SYSCTL_CHILDREN(sysctl_tree), OID_AUTO,
+			    "als", CTLTYPE_INT | CTLFLAG_RD,
+			    sc, ISL_METHOD_ALS, isl_sysctl, "I",
+			    "Current ALS sensor read-out");
+	}
+
+	if (use_ir) {
+		SYSCTL_ADD_PROC(sysctl_ctx,
+			SYSCTL_CHILDREN(sysctl_tree), OID_AUTO,
+			    "ir", CTLTYPE_INT | CTLFLAG_RD,
+			    sc, ISL_METHOD_IR, isl_sysctl, "I",
+			    "Current IR sensor read-out");
+	}
+
+	if (use_prox) {
+		SYSCTL_ADD_PROC(sysctl_ctx,
+			SYSCTL_CHILDREN(sysctl_tree), OID_AUTO,
+			    "prox", CTLTYPE_INT | CTLFLAG_RD,
+			    sc, ISL_METHOD_PROX, isl_sysctl, "I",
+			    "Current proximity sensor read-out");
+	}
+
+	SYSCTL_ADD_PROC(sysctl_ctx,
+		SYSCTL_CHILDREN(sysctl_tree), OID_AUTO,
+		    "resolution", CTLTYPE_INT | CTLFLAG_RD,
+		    sc, ISL_METHOD_RESOLUTION, isl_sysctl, "I",
+		    "Current proximity sensor resolution");
+
+	SYSCTL_ADD_PROC(sysctl_ctx,
+	SYSCTL_CHILDREN(sysctl_tree), OID_AUTO,
+	    "range", CTLTYPE_INT | CTLFLAG_RD,
+	    sc, ISL_METHOD_RANGE, isl_sysctl, "I",
+	    "Current proximity sensor range");
+
+	return (0);
+}
+
+static int
+isl_detach(device_t dev)
+{
+	struct isl_softc *sc;
+
+	sc = device_get_softc(dev);
+	sx_destroy(&sc->isl_sx);
+
+	return (0);
+}
+
+static int
+isl_sysctl(SYSCTL_HANDLER_ARGS)
+{
+	static int resolutions[] = { 16, 12, 8, 4};
+	static int ranges[] = { 1000, 4000, 16000, 64000};
+
+	struct isl_softc *sc;
+	device_t bus;
+	uint8_t rbyte;
+	int arg;
+	int resolution;
+	int range;
+
+	sc = (struct isl_softc *)oidp->oid_arg1;
+	arg = -1;
+
+	sx_xlock(&sc->isl_sx);
+	bus = device_get_parent(sc->dev);	/* smbus */
+	if (smbus_trans(bus, sc->addr, REG_CMD2,
+	    SMB_TRANS_NOCNT | SMB_TRANS_7BIT,
+	    NULL, 0, &rbyte, sizeof(rbyte), NULL)) {
+		sx_xunlock(&sc->isl_sx);
+		return (-1);
+	}
+	resolution = resolutions[(rbyte & CMD2_MASK_RESOLUTION)
+			    >> CMD2_SHIFT_RESOLUTION];
+	range = ranges[(rbyte & CMD2_MASK_RANGE) >> CMD2_SHIFT_RANGE];
+
+	switch (oidp->oid_arg2) {
+	case ISL_METHOD_ALS:
+		arg = (isl_read_sensor(sc->dev, sc->addr,
+		    CMD1_MASK_ALS_ONCE) * range) >> resolution;
+		break;
+	case ISL_METHOD_IR:
+		arg = isl_read_sensor(sc->dev, sc->addr,
+		    CMD1_MASK_IR_ONCE);
+		break;
+	case ISL_METHOD_PROX:
+		arg = isl_read_sensor(sc->dev, sc->addr,
+		    CMD1_MASK_PROX_ONCE);
+		break;
+	case ISL_METHOD_RESOLUTION:
+		arg = (1 << resolution);
+		break;
+	case ISL_METHOD_RANGE:
+		arg = range;
+		break;
+	}
+	sx_xunlock(&sc->isl_sx);
+
+	SYSCTL_OUT(req, &arg, sizeof(arg));
+	return (0);
+}
+
+static int
+isl_read_sensor(device_t dev, int addr, uint8_t cmd_mask)
+{
+	device_t bus;
+	uint8_t rbyte;
+	uint8_t cmd;
+	int ret;
+
+	bus = device_get_parent(dev);	/* smbus */
+
+	if (smbus_trans(bus, addr, REG_CMD1,
+	    SMB_TRANS_NOCNT | SMB_TRANS_7BIT,
+	    NULL, 0, &rbyte, sizeof(rbyte), NULL)) {
+		device_printf(dev,
+		    "Couldn't read first byte before issuing command %d\n",
+		    cmd_mask);
+		return (-1);
+	}
+
+	cmd = (rbyte & 0x1f) | cmd_mask;
+	if (smbus_trans(bus, addr, REG_CMD1,
+	    SMB_TRANS_NOCNT | SMB_TRANS_7BIT,
+	    &cmd, sizeof(cmd), NULL, 0, NULL)) {
+		device_printf(dev, "Couldn't write command %d\n", cmd_mask);
+		return (-1);
+	}
+
+	pause("islconv", hz/10);
+
+	if (smbus_trans(bus, addr, REG_DATA1,
+	    SMB_TRANS_NOCNT | SMB_TRANS_7BIT,
+	    NULL, 0, &rbyte, sizeof(rbyte), NULL)) {
+		device_printf(dev,
+		    "Couldn't read first byte after command %d\n", cmd_mask);
+		return (-1);
+	}
+
+	ret = rbyte;
+	if (smbus_trans(bus, addr, REG_DATA2,
+	    SMB_TRANS_NOCNT | SMB_TRANS_7BIT,
+	    NULL, 0, &rbyte, sizeof(rbyte), NULL)) {
+		device_printf(dev, "Couldn't read second byte after command %d\n", cmd_mask);
+		return (-1);
+	}
+	ret += rbyte << 8;
+
+	return (ret);
+}
+
+DRIVER_MODULE(isl, smbus, isl_driver, isl_devclass, NULL, NULL);
+MODULE_DEPEND(isl, smbus, SMBUS_MINVER, SMBUS_PREFVER, SMBUS_MAXVER);
+MODULE_VERSION(isl, 1);

Index: sys/dev/isl/isl.h
===================================================================
--- sys/dev/isl/isl.h	(revision 0)
+++ sys/dev/isl/isl.h	(working copy)
@@ -0,0 +1,63 @@
+/*-
+ * Copyright (c) 2015 Michael Gmelin <freebsd@grem.de>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD$
+ */
+
+#ifndef _ISL_H_
+#define _ISL_H_
+
+/* Command register 1  (bits 7-5) */
+#define REG_CMD1		0x00
+#define CMD1_MASK_POWER_DOWN	0x00      /* 00000000 */
+#define CMD1_MASK_ALS_ONCE	0x01 << 5 /* 00100000 */
+#define CMD1_MASK_IR_ONCE	0x02 << 5 /* 01000000 */
+#define CMD1_MASK_PROX_ONCE	0x03 << 5 /* 01100000 */
+/* RESERVED */                            /* 10000000 */
+#define CMD1_MASK_ALS_CONT	0x05 << 5 /* 10100000 */
+#define CMD1_MASK_IR_CONT	0x06 << 5 /* 11000000 */
+#define CMD1_MASK_PROX_CONT	0x07 << 5 /* 11100000 */
+
+/* Command register 2 (bits) */
+#define REG_CMD2		0x01
+
+/* data registers */
+#define REG_DATA1		0x02
+#define REG_DATA2		0x03
+#define CMD2_SHIFT_RANGE	0x00
+#define CMD2_MASK_RANGE		(0x03 << CMD2_SHIFT_RANGE)
+#define CMD2_SHIFT_RESOLUTION	0x02
+#define CMD2_MASK_RESOLUTION	(0x03 << CMD2_SHIFT_RESOLUTION)
+
+/* Interrupt registers */
+#define REG_INT_LO_LSB		0x04
+#define REG_INT_LO_MSB		0x05
+#define REG_INT_HI_LSB		0x06
+#define REG_INT_HI_MSB		0x07
+
+/* Test register (should hold 0x00 at all times */
+#define REG_TEST		0x08
+
+#endif

Index: sys/dev/smbus/smb.c
===================================================================
--- sys/dev/smbus/smb.c	(revision 287980)
+++ sys/dev/smbus/smb.c	(working copy)
@@ -26,10 +26,6 @@
  * $FreeBSD$
  */
 
-#ifdef HAVE_KERNEL_OPTION_HEADERS
-#include "opt_compat.h"
-#endif
-
 #include <sys/param.h>
 #include <sys/kernel.h>
 #include <sys/systm.h>
@@ -104,9 +100,11 @@
 static int
 smb_probe(device_t dev)
 {
+	if (smbus_get_addr(dev) != -1)
+		return (ENXIO);
+
 	device_set_desc(dev, "SMBus generic I/O");
-
-	return (0);
+	return (BUS_PROBE_NOWILDCARD);
 }
 	
 static int
@@ -113,10 +111,13 @@
 smb_attach(device_t dev)
 {
 	struct smb_softc *sc = device_get_softc(dev);
+	int unit;
+	
+	unit = device_get_unit(dev);
+	sc->sc_dev = dev;
 
-	sc->sc_dev = dev;
-	sc->sc_devnode = make_dev(&smb_cdevsw, device_get_unit(dev),
-	    UID_ROOT, GID_WHEEL, 0600, "smb%d", device_get_unit(dev));
+	sc->sc_devnode = make_dev(&smb_cdevsw, unit, UID_ROOT, GID_WHEEL,
+	    0600, "smb%d", unit);
 	sc->sc_devnode->si_drv1 = sc;
 	mtx_init(&sc->sc_lock, device_get_nameunit(dev), NULL, MTX_DEF);
 
@@ -174,10 +175,17 @@
 	struct smb_softc *sc = dev->si_drv1;
 	device_t smbdev = sc->sc_dev;
 	int error;
-	short w;
-	u_char count;
-	char c;
+	int unit;
+	u_char bcount;
 
+	/*
+	 * If a specific slave device is being used, override any passed-in
+	 * slave.
+	 */
+	unit = dev2unit(dev);
+	if (unit & 0x0400)
+		s->slave = unit & 0x03ff;
+
 	parent = device_get_parent(smbdev);
 
 	/* Make sure that LSB bit is cleared. */
@@ -208,77 +216,101 @@
 
 	case SMB_WRITEB:
 		error = smbus_error(smbus_writeb(parent, s->slave, s->cmd,
-						s->data.byte));
+						s->wdata.byte));
 		break;
 
 	case SMB_WRITEW:
 		error = smbus_error(smbus_writew(parent, s->slave,
-						s->cmd, s->data.word));
+						s->cmd, s->wdata.word));
 		break;
 
 	case SMB_READB:
-		if (s->data.byte_ptr) {
-			error = smbus_error(smbus_readb(parent, s->slave,
-						s->cmd, &c));
-			if (error)
-				break;
-			error = copyout(&c, s->data.byte_ptr,
-					sizeof(*(s->data.byte_ptr)));
+		error = smbus_error(smbus_readb(parent, s->slave, s->cmd,
+		    &s->rdata.byte));
+		if (error)
+			break;
+		if (s->rbuf && s->rcount >= 1) {
+			error = copyout(&s->rdata.byte, s->rbuf, 1);
+			s->rcount = 1;
 		}
 		break;
 
 	case SMB_READW:
-		if (s->data.word_ptr) {
-			error = smbus_error(smbus_readw(parent, s->slave,
-						s->cmd, &w));
-			if (error == 0) {
-				error = copyout(&w, s->data.word_ptr,
-						sizeof(*(s->data.word_ptr)));
-			}
+		error = smbus_error(smbus_readw(parent, s->slave, s->cmd,
+		    &s->rdata.word));
+		if (error)
+			break;
+		if (s->rbuf && s->rcount >= 2) {
+			buf[0] = (u_char)s->rdata.word;
+			buf[1] = (u_char)(s->rdata.word >> 8);
+			error = copyout(buf, s->rbuf, 2);
+			s->rcount = 2;
 		}
 		break;
 
 	case SMB_PCALL:
-		if (s->data.process.rdata) {
+		error = smbus_error(smbus_pcall(parent, s->slave, s->cmd,
+		    s->wdata.word, &s->rdata.word));
+		if (error)
+			break;
+		if (s->rbuf && s->rcount >= 2) {
+			buf[0] = (u_char)s->rdata.word;
+			buf[1] = (u_char)(s->rdata.word >> 8);
+			error = copyout(buf, s->rbuf, 2);
+			s->rcount = 2;
+		}
 
-			error = smbus_error(smbus_pcall(parent, s->slave, s->cmd,
-				s->data.process.sdata, &w));
-			if (error)
-				break;
-			error = copyout(&w, s->data.process.rdata,
-					sizeof(*(s->data.process.rdata)));
-		}
-		
 		break;
 
 	case SMB_BWRITE:
-		if (s->count && s->data.byte_ptr) {
-			if (s->count > SMB_MAXBLOCKSIZE)
-				s->count = SMB_MAXBLOCKSIZE;
-			error = copyin(s->data.byte_ptr, buf, s->count);
-			if (error)
-				break;
-			error = smbus_error(smbus_bwrite(parent, s->slave,
-						s->cmd, s->count, buf));
+		if (s->wcount < 0) {
+			error = EINVAL;
+			break;
 		}
+		if (s->wcount > SMB_MAXBLOCKSIZE)
+			s->wcount = SMB_MAXBLOCKSIZE;
+		if (s->wcount)
+			error = copyin(s->wbuf, buf, s->wcount);
+		if (error)
+			break;
+		error = smbus_error(smbus_bwrite(parent, s->slave, s->cmd,
+		    s->wcount, buf));
 		break;
 
-#if defined(COMPAT_FREEBSD4) || defined(COMPAT_FREEBSD5) || defined(COMPAT_FREEBSD6)
-	case SMB_OLD_BREAD:
-#endif
 	case SMB_BREAD:
-		if (s->count && s->data.byte_ptr) {
-			count = min(s->count, SMB_MAXBLOCKSIZE);
-			error = smbus_error(smbus_bread(parent, s->slave,
-						s->cmd, &count, buf));
-			if (error)
-				break;
-			error = copyout(buf, s->data.byte_ptr,
-			    min(count, s->count));
-			s->count = count;
+		if (s->rcount < 0) {
+			error = EINVAL;
+			break;
 		}
+		if (s->rcount > SMB_MAXBLOCKSIZE)
+			s->rcount = SMB_MAXBLOCKSIZE;
+		error = smbus_error(smbus_bread(parent, s->slave, s->cmd,
+		    &bcount, buf));
+		if (error)
+			break;
+		if (s->rcount > bcount)
+			s->rcount = bcount;
+		error = copyout(buf, s->rbuf, s->rcount);
 		break;
-		
+
+	case SMB_TRANS:
+		if (s->rcount < 0 || s->wcount < 0) {
+			error = EINVAL;
+			break;
+		}
+		if (s->rcount > SMB_MAXBLOCKSIZE)
+			s->rcount = SMB_MAXBLOCKSIZE;
+		if (s->wcount > SMB_MAXBLOCKSIZE)
+			s->wcount = SMB_MAXBLOCKSIZE;
+		if (s->wcount)
+			error = copyin(s->wbuf, buf, s->wcount);
+		if (error)
+			break;
+		error = smbus_error(smbus_trans(parent, s->slave, s->cmd,
+		    s->op, buf, s->wcount, buf, s->rcount, &s->rcount));
+		if (error == 0)
+			error = copyout(buf, s->rbuf, s->rcount);
+		break;
 	default:
 		error = ENOTTY;
 	}
Index: sys/dev/smbus/smb.h
===================================================================
--- sys/dev/smbus/smb.h	(revision 287980)
+++ sys/dev/smbus/smb.h	(working copy)
@@ -32,27 +32,33 @@
 #include <sys/ioccom.h>
 
 struct smbcmd {
-	char cmd;
-	int count;
-	u_char slave;
+	u_char cmd;
+	u_char reserved;
+	u_short op;
 	union {
-		char byte;
-		short word;
-
-		char *byte_ptr;
-		short *word_ptr;
-
-		struct {
-			short sdata;
-			short *rdata;
-		} process;
-	} data;
+		char	byte;
+		char	buf[2];
+		short	word;
+	} wdata;
+	union {
+		char	byte;
+		char	buf[2];
+		short	word;
+	} rdata;
+	int  slave;
+	char *wbuf;	/* use wdata if NULL */
+	int  wcount;
+	char *rbuf;	/* use rdata if NULL */
+	int  rcount;
 };
 
 /*
  * SMBus spec 2.0 says block transfers may be at most 32 bytes.
+ * We use SMBus for i2c as well, make the size limit something more
+ * reasonable.  Keep in mind that a char buf array is declared on the
+ * kernel stack.
  */
-#define SMB_MAXBLOCKSIZE	32
+#define SMB_MAXBLOCKSIZE	1024
 
 #define SMB_QUICK_WRITE	_IOW('i', 1, struct smbcmd)
 #define SMB_QUICK_READ	_IOW('i', 2, struct smbcmd)
@@ -66,5 +72,6 @@
 #define SMB_BWRITE	_IOW('i', 10, struct smbcmd)
 #define SMB_OLD_BREAD	_IOW('i', 11, struct smbcmd)
 #define SMB_BREAD	_IOWR('i', 11, struct smbcmd)
+#define SMB_TRANS	_IOWR('i', 12, struct smbcmd)
 
 #endif
Index: sys/dev/smbus/smbconf.h
===================================================================
--- sys/dev/smbus/smbconf.h	(revision 287980)
+++ sys/dev/smbus/smbconf.h	(working copy)
@@ -68,9 +68,30 @@
 #define SMB_QREAD	0x1
 
 /*
+ * smbus transction op with pass-thru capabilities
+ *
+ * This smbus function is capable of doing a smbus command transaction
+ * (read or write), and can be flagged to not issue the 'cmd' and/or
+ * issue or expect a count field as well as flagged for chaining (no STOP),
+ * which gives it an i2c pass-through capability.
+ *
+ * NOSTOP- Caller chaining transactions, do not issue STOP
+ * NOCMD-  Do not transmit the command field
+ * NOCNT-  Do not transmit (wr) or expect (rd) the count field
+ */
+#define SMB_TRANS_NOSTOP  0x0001  /* do not send STOP at end */
+#define SMB_TRANS_NOCMD   0x0002  /* ignore cmd field (do not tx) */ 
+#define SMB_TRANS_NOCNT   0x0004  /* do not tx or rx count field */  
+#define SMB_TRANS_7BIT    0x0008  /* change address mode to 7-bit */ 
+#define SMB_TRANS_10BIT   0x0010  /* change address mode to 10-bit */
+#define SMB_TRANS_NOREPORT  0x0020  /* do not report errors */
+
+/*
  * ivars codes
  */
-#define SMBUS_IVAR_ADDR	0x1	/* slave address of the device */
+enum smbus_ivars {
+    SMBUS_IVAR_ADDR,	/* slave address of the device */
+};
 
 int	smbus_request_bus(device_t, device_t, int);
 int	smbus_release_bus(device_t, device_t);
@@ -79,8 +100,13 @@
 
 void	smbus_intr(device_t, u_char, char low, char high, int error);
 
-u_char	smbus_get_addr(device_t);
+#define SMBUS_ACCESSOR(var, ivar, type)					\
+	__BUS_ACCESSOR(smbus, var, SMBUS, ivar, type)
 
+SMBUS_ACCESSOR(addr,		ADDR,		int)
+
+#undef SMBUS_ACCESSOR
+
 extern driver_t smbus_driver;
 extern devclass_t smbus_devclass;
 
@@ -104,6 +130,9 @@
 	(SMBUS_BWRITE(device_get_parent(bus), slave, cmd, count, buf))
 #define smbus_bread(bus,slave,cmd,count,buf) \
 	(SMBUS_BREAD(device_get_parent(bus), slave, cmd, count, buf))
+#define smbus_trans(bus,slave,cmd,op,wbuf,wcount,rbuf,rcount,actualp) \
+	(SMBUS_TRANS(device_get_parent(bus), slave, cmd, op, \
+	wbuf, wcount, rbuf, rcount, actualp))
 
 #define SMBUS_MODVER	1
 #define SMBUS_MINVER	1
Index: sys/dev/smbus/smbus.c
===================================================================
--- sys/dev/smbus/smbus.c	(revision 287980)
+++ sys/dev/smbus/smbus.c	(working copy)
@@ -33,11 +33,15 @@
 #include <sys/lock.h>
 #include <sys/module.h>
 #include <sys/mutex.h>
-#include <sys/bus.h> 
+#include <sys/bus.h>
 
 #include <dev/smbus/smbconf.h>
 #include <dev/smbus/smbus.h>
 
+#include "smbus_if.h"
+#include "bus_if.h"
+
+
 /*
  * Autoconfiguration and support routines for System Management bus
  */
@@ -49,6 +53,13 @@
 static int smbus_attach(device_t);
 static int smbus_detach(device_t);
 
+static int smbus_child_location_str(device_t parent, device_t child,
+		    char *buf, size_t buflen);
+static int smbus_print_child(device_t parent, device_t child);
+static void smbus_probe_device(device_t dev, u_char* addr);
+static int smbus_read_ivar(device_t parent, device_t child, int which,
+		    uintptr_t *result);
+
 static device_method_t smbus_methods[] = {
         /* device interface */
         DEVMETHOD(device_probe,         smbus_probe),
@@ -57,6 +68,10 @@
 
 	/* bus interface */
 	DEVMETHOD(bus_add_child,	bus_generic_add_child),
+	DEVMETHOD(bus_child_location_str, smbus_child_location_str),
+	DEVMETHOD(bus_driver_added,	bus_generic_driver_added),
+	DEVMETHOD(bus_print_child,	smbus_print_child),
+	DEVMETHOD(bus_read_ivar,	smbus_read_ivar),
 
 	DEVMETHOD_END
 };
@@ -87,9 +102,14 @@
 smbus_attach(device_t dev)
 {
 	struct smbus_softc *sc = device_get_softc(dev);
+	unsigned char addr;
 
 	mtx_init(&sc->lock, device_get_nameunit(dev), "smbus", MTX_DEF);
 	bus_generic_probe(dev);
+	for (addr = SMBUS_ADDR_MIN; addr < SMBUS_ADDR_MAX; ++addr) {
+		sc->addrs[addr] = addr;
+		smbus_probe_device(dev, &sc->addrs[addr]);
+	}
 	bus_generic_attach(dev);
 
 	return (0);
@@ -114,4 +134,70 @@
 {
 }
 
+static void
+smbus_probe_device(device_t dev, u_char* addr)
+{
+	device_t child;
+	int error;
+	u_char cmd;
+	u_char buf[2];
+
+	cmd = 0x01;
+	error = smbus_trans(dev, *addr, cmd,
+			    SMB_TRANS_NOCNT | SMB_TRANS_NOREPORT,
+			    NULL, 0, buf, 1, NULL);
+	if (error == 0) {
+		if (bootverbose)
+			device_printf(dev, "Probed address 0x%02x\n", *addr);
+		child = device_add_child(dev, NULL, -1);
+		device_set_ivars(child, addr);
+	}
+}
+
+static int
+smbus_child_location_str(device_t parent, device_t child, char *buf,
+    size_t buflen)
+{
+	unsigned char *addr;
+
+	addr = device_get_ivars(child);
+	if (addr)
+		snprintf(buf, buflen, "addr=0x%x", *addr);
+	else if (buflen)
+		buf[0] = 0;
+	return (0);
+}
+
+static int
+smbus_print_child(device_t parent, device_t child)
+{
+	unsigned char *addr;
+	int retval;
+
+	addr = device_get_ivars(child);
+	retval = bus_print_child_header(parent, child);
+	if (addr)
+		retval += printf(" at addr 0x%x", *addr);
+	retval += bus_print_child_footer(parent, child);
+
+	return (retval);
+}
+
+static int
+smbus_read_ivar(device_t parent, device_t child, int which,
+    uintptr_t *result)
+{
+	unsigned char *addr;
+
+	addr = device_get_ivars(child);
+	switch (which) {
+	case SMBUS_IVAR_ADDR:
+		*result = (addr == NULL) ? -1 : *addr;
+		break;
+	default:
+		return (ENOENT);
+	}
+	return (0);
+}
+
 MODULE_VERSION(smbus, SMBUS_MODVER);
Index: sys/dev/smbus/smbus.h
===================================================================
--- sys/dev/smbus/smbus.h	(revision 287980)
+++ sys/dev/smbus/smbus.h	(working copy)
@@ -29,9 +29,13 @@
 #ifndef __SMBUS_H
 #define __SMBUS_H
 
+#define SMBUS_ADDR_MIN	0x10
+#define SMBUS_ADDR_MAX	0x70
+
 struct smbus_softc {
 	device_t owner;		/* smbus owner device structure */
 	struct mtx lock;
+	unsigned char addrs[SMBUS_ADDR_MAX];
 };
 
 void smbus_generic_intr(device_t dev, u_char devaddr, char low, char high, int err);
Index: sys/dev/smbus/smbus_if.m
===================================================================
--- sys/dev/smbus/smbus_if.m	(revision 287980)
+++ sys/dev/smbus/smbus_if.m	(working copy)
@@ -149,3 +149,20 @@
 	u_char *count;
 	char *buf;
 };
+
+#
+# SMB roll-up transaction with flags that also allow it to be     
+# used for (mostly) i2c pass-through and with 10-bit addresses.   
+# This function can be used to roll-up all of the above functions.
+#
+METHOD int trans {       
+	device_t dev;    
+	int     slave;   
+	char    cmd;     
+	int     op;      
+	char    *wbuf;   
+	int     wcount;  
+	char    *rbuf;   
+	int     rcount;  
+	int     *actualp;
+};
Index: sys/modules/i2c/Makefile
===================================================================
--- sys/modules/i2c/Makefile	(revision 287980)
+++ sys/modules/i2c/Makefile	(working copy)
@@ -1,6 +1,6 @@
 # $FreeBSD$
 
 SUBDIR =
-SUBDIR += controllers if_ic smbus iicbus iicbb iicsmb iic smb
+SUBDIR += controllers if_ic smbus iicbus iicbb iicsmb iic cyapa smb isl
 
 .include <bsd.subdir.mk>
Index: sys/modules/i2c/controllers/Makefile
===================================================================
--- sys/modules/i2c/controllers/Makefile	(revision 287980)
+++ sys/modules/i2c/controllers/Makefile	(working copy)
@@ -3,7 +3,7 @@
 .if ${MACHINE} == "pc98"
 SUBDIR = lpbb
 .else
-SUBDIR = alpm amdpm amdsmb ichsmb intpm nfsmb viapm lpbb pcf
+SUBDIR = alpm amdpm amdsmb ichiic ichsmb intpm nfsmb viapm lpbb pcf
 .endif
 
 .include <bsd.subdir.mk>
Index: sys/modules/i2c/controllers/ichiic/Makefile
===================================================================
--- sys/modules/i2c/controllers/ichiic/Makefile	(revision 0)
+++ sys/modules/i2c/controllers/ichiic/Makefile	(working copy)
@@ -0,0 +1,8 @@
+#$FreeBSD$
+
+.PATH:		${.CURDIR}/../../../../dev/ichiic
+KMOD		= ig4
+SRCS		= device_if.h bus_if.h iicbb_if.h pci_if.h smbus_if.h \
+		  ig4_iic.c ig4_pci.c ig4_reg.h ig4_var.h
+
+.include <bsd.kmod.mk>

Index: sys/modules/i2c/cyapa/Makefile
===================================================================
--- sys/modules/i2c/cyapa/Makefile	(revision 0)
+++ sys/modules/i2c/cyapa/Makefile	(working copy)
@@ -0,0 +1,7 @@
+# $FreeBSD$
+
+.PATH:		${.CURDIR}/../../../dev/cyapa
+KMOD		= cyapa
+SRCS		= cyapa.c device_if.h bus_if.h smbus_if.h vnode_if.h
+
+.include <bsd.kmod.mk>

Index: sys/modules/i2c/isl/Makefile
===================================================================
--- sys/modules/i2c/isl/Makefile	(revision 0)
+++ sys/modules/i2c/isl/Makefile	(working copy)
@@ -0,0 +1,7 @@
+# $FreeBSD$
+
+.PATH:		${.CURDIR}/../../../dev/isl
+KMOD		= isl
+SRCS		= isl.c device_if.h bus_if.h smbus_if.h vnode_if.h
+
+.include <bsd.kmod.mk>

